/* 
 * WPILib.java
 *
 * Created on 13. únor 2008, 12:12
 */

package wpi;

import java.io.*;
import java.applet.*;
import java.sql.*;
import java.util.*;
/**
 *
 * @author  Adam Kopřiva
 * 
 */
public class WPILib {
       
       public static String status= ""; 
       public static String conectFile="connect.dat"; 
   //    public static String initConnect = "jdbc:mysql://localhost/wordnet30?user=root&password="; 
         public static String initConnect = "jdbc:mysql://minerva2.fit.vutbr.cz/wordnet30?user=wordnet&password=bRLNBWSnxxUanRn4";
                                            //"jdbc:mysql://minerva2.fit.vutbr.cz/wordnet30?user=wordnet&password=bRLNBWSnxxUanRn4");
       public static Statement connect = null;
  //     public static Statement connect = Connect("jdbc:mysql://localhost/var/run/mysql/mysql.sock/wordnet30?user=xkopri06&password=kerpu7na");
      
     public static String initConnection() {
        try {
            
          
            int i = 0;

            File data = new File(conectFile);

            if (!data.exists()) {
                
                 return initConnect;

            }
            
            
            if (data.length()<1) {
                
                return initConnect;
            }

            FileReader fr = new FileReader(conectFile);
            BufferedReader in = new BufferedReader(fr);

            String radka;

            radka = in.readLine();
            
            fr.close();
            
         
       
        return radka;
            
        } catch (IOException ex) {
           return initConnect;
        }
        
    }
    
     
    /**
     * Metoda, která najde slovo podle zadaného id
     * @param wordid - id slova které hledáme
     */
    public static String FindLemma(String wordid) throws Exception{            
          
        try {
          String query =  "SELECT lemma FROM word WHERE wordid = "+quotate(wordid)+"";

          ResultSet rs = MakeQuery(connect, query);
            
          if (rs.next()) return rs.getString("lemma");
          else return null;
        
          } catch (Exception e) {
             System.out.println("Chyba při hledání id slova");
             throw e;
         }
         
     }
     /**
     * Metoda, která najde všechny významy od zadaného slova
     * @param word - slova od kterého hledáme významy
     */
       public static List GetSenses(String word) throws Exception{     
        try { 
                 
              List synsets = new ArrayList(0);
              List senses = new ArrayList(0);
            
              synsets = FindSynsets(FindWordId(word));
              senses = FindSense(synsets);
                
          
            return senses;
        }
        catch (Exception e) {
            System.out.println("Chyba při hledání synonym");
            throw e;
         }
                
    }
    
     /**
     * Metoda, která najde synonyma od zadené kolekce synsetů
     * @param synsets - kolekce synsetů od zadaného slova
     */
       public static List GetSynonyms(List synsets) throws Exception{     
        try { 
              List synonymsid = new ArrayList(0);
              List synonyms = new ArrayList(0);
            
              synonymsid = FindSynonyms(synsets);
                      
              Iterator it = synonymsid.iterator(); 
               
               while (it.hasNext()) {
                   
                     synonyms.add( FindLemma((String) it.next()));

               }
                
          
            return synonyms;
        }
        catch (Exception e) {
            System.out.println("Chyba při hledání synonym");
            throw e;
         }
                
    }
    
    /**
     * Metoda, která najde všechny wordid od zadané kolekce synsetů
     * @param synsets - kolekce synsetů od zadaného slova
     */
     public static List FindSynonyms(List synsets) throws Exception{     
        try {   
              List synonymsid = new ArrayList(0);
              String pom = "";
              Iterator it = synsets.iterator(); 
               
               while (it.hasNext()) {
                   
                    String query = "SELECT wordid FROM sense WHERE synsetid = "+quotate((String) it.next())+"";
            
                    ResultSet rs = MakeQuery(connect, query);
            
                    while (rs.next()) if(!(synonymsid.contains(pom = rs.getString("wordid")))) synonymsid.add(pom);
           
               }
                
          
            return synonymsid;
        }
        catch (Exception e) {
            System.out.println("Chyba pĹ™i hledĂˇnĂ­ synonym");
            throw e;
         }
                
    }
      
     /**
     * Metoda, která vybere z kolekce zadaný slovní druh
     * n - noun, v - verb, a,s - adjective r - adverb
     * @param Col - kolekce slov
     * @param wc - slovní druh, 
     */
    public static List GetWordClass(List Col, char wc) throws Exception{     
        try {
             List CurrentWordClass = new ArrayList(0);
             Iterator it = Col.iterator(); 
             
          
            String str = "";
             
             
             while (it.hasNext()) {
                    
                    Scanner scan = new Scanner((String) it.next()).useDelimiter("\\|\\s*");
                    str = scan.next();
                    if (str.indexOf(wc) != -1) CurrentWordClass.add(scan.next()+"|"+scan.next());
                 //   System.out.println(str);
                    
                }
          
            return CurrentWordClass;
        }
        catch (Exception e) {
            System.out.println("Chyba při získávání významu slova");
            throw e;
         }
                
    }
    
    /**
     * Metoda, vrací definice od zadaného slova
     * @param word - Slovo jehož významy hledáme
     */
    public static List GetSense(String word) throws Exception{     
        try {
          return FindSense(FindSynsets(FindWordId(word)));
        }
        catch (Exception e) {
            System.out.println("Chyba při získávání významu slova");
            throw e;
         }
                
    }
    
    /**
     * Metoda, která vloží slovo do apostrofů 
     * @param content - slovo které chceme vložit do apostrofů
     */
    public static String quotate(String content){            
        return "'"+content+"'";    
        }
    
    /**
     * Metoda, která najde id slova od které hledáme
     * @param word - slovo jehož id hledáme
     */
    public static String FindWordId(String word) throws Exception{            
          
        try {
          String query =  "SELECT wordid FROM word WHERE lemma = "+quotate(word)+"";
                  
          
          ResultSet rs = MakeQuery(connect, query);
            
          if (rs.next()) return rs.getString("wordid");
          else return null;
        
          } catch (Exception e) {
             System.out.println("Chyba při hledání id slova");
             throw e;
         }
         
     }
    
    /**
     * Metoda, která najde synsety od zadaného slova
     * @param word - slovo od kterého hledáme synsety
     */
    public static List FindSynsets(String wordid) throws Exception{            
          
        try {
            List synsets = new ArrayList(0);
            
            String query = "SELECT synsetid FROM sense WHERE wordid = "+quotate(wordid)+"";
            
            ResultSet rs = MakeQuery(connect, query);
            
             while (rs.next()) synsets.add( rs.getString("synsetid"));
           
            return synsets;
        
          } catch (Exception e) {
             System.out.println("Chyba při hledání synsetů");
             throw e;
         }
         
     }
    
   /**
     * Metoda, která najde id synonym k zadanému synsetu
     * @param sinsetid - slovo od kterého hledáme synsety
     */
    public static List FindSynonymsIdFromSynsets(String synsetid) throws Exception{            
          
        try {
            List synonyms = new ArrayList(0);
            
            String query = "SELECT wordid FROM sense WHERE synsetid = "+quotate(synsetid)+"";
            
            ResultSet rs = MakeQuery(connect, query);
            
             while (rs.next()) synonyms.add( rs.getString("wordid"));
           
            return synonyms;
        
          } catch (Exception e) {
             System.out.println("Chyba při hledání synonym od synsetů");
             throw e;
         }
         
     }
    
    /**
     * Metoda, která najde synonyma k zadanému id synsetu
     * @param sinsetid - slovo od kterého hledáme synsety
     */
    public static List FindSynonymsFromSynsets(String synsetid, String word) throws Exception{            
          
        try {
            List synonymsId = new ArrayList(0);
            List synonyms = new ArrayList(0);
            String pom = "";
            synonymsId =  FindSynonymsIdFromSynsets(synsetid);
            
             Iterator it = synonymsId.iterator(); 
               
               while (it.hasNext()) {
                    
                     pom = FindLemma((String) it.next());
                     if(!pom.equals(word)) synonyms.add(pom);

               }
           
            return synonyms;
        
          } catch (Exception e) {
             System.out.println("Chyba při hledání synonym od synsetů");
             throw e;
         }
         
     }
    
   
   
    
     /**
     * Metoda, která najde významy od zadaných synsetů
     * @param synsets - kolekce synsetů
     */
     public static List FindSense(List synsets) throws Exception{            
          
        try {
            String synsetid ="";
            String sense = "";
            String query = "";
            String sample = "";
            String sam = "";
                        
            Iterator it = synsets.iterator();  
            List senses = new ArrayList(0);
            
            
              // dokud máme čísla synsetů tak hledáme definice a příklady  
              while (it.hasNext()) {
                  
                   // načtení id synsetu a vyhledání jeho definice
                   synsetid = (String) it.next();
              
                   query = "SELECT * FROM synset WHERE synsetid = "+quotate(synsetid)+"";
            
                   ResultSet rs = MakeQuery(connect, query);
                   
                   // pokud najdeme číslo synsetu uložíme definici
                   if (rs.next()) sense = rs.getString("pos") + " | "+ synsetid+ " | "+rs.getString("definition");
                    
                    // hledáme jestli existují příklady 
                    query =  "SELECT sample FROM sample WHERE synsetid = "+quotate(synsetid)+"";
            
                    ResultSet rs2 = MakeQuery(connect, query);
                   
                     // dokud máme příklady tak je načítáme a oddělujeme uvozovkami
                     while (rs2.next()) {
                
                         sample = rs2.getString("sample");
                         sam = sam+"\""+ sample+"\"; ";

                      }
                    
                     // nakonec spojíme definici s příklady a vložíme do kolekce 
                     if(sam.equals("")) senses.add(sense); 
                     else senses.add(sense+": "+sam);  
                         // senses.add(sense+"\n"+sam);
                     sam = "";
                     
                     
                   }
          return senses;
 
          
          } catch (Exception e) {
             System.out.println("Chyba při hledání významu");
             throw e;
         }
         
     }
    
  
    
    
   /**
     * Metoda, která nás připojí k databázi
     */
    public static Statement Connect(String server) {     
        
         try {
          
            Class.forName("com.mysql.jdbc.Driver").newInstance();
           
            Connection mysql = DriverManager.getConnection(server);
        
            // Connection mysql = DriverManager.getConnection("jdbc:mysql://localhost/wordnet30?user=root&password=");
          //  Connection mysql = DriverManager.getConnection("jdbc:mysql://minerva2.fit.vutbr.cz/wordnet30?user=wordnet&password=bRLNBWSnxxUanRn4");
            Statement mystmt = mysql.createStatement();
            
            status = "Connected";
            
         return mystmt;
         
         } catch (Exception e) {
  
            status = "Database connection error - wrong connection\n ";
            System.out.println("Chyba při připojení do databáze:\n"+e);
            return null;
         }
         
    }
    
    /**
     * Metoda, vykoná databázový příkaz
     * @param mystmt - Statestment připojení k databázi
     * @param query - příkaz který se má vykonat
     */
    public static ResultSet MakeQuery(Statement mystmt, String query) throws Exception{     
        try {
          return mystmt.executeQuery(query);
        }
        catch (Exception e) {
            System.out.println("Chyba při vykonování dotazu v databázi");
            status = "Database query error - probably you are not connected";
            throw e;
         }
                
    }
    
     /**
     * Metoda, která najde antonyma od zadaného slova
     * @param word - slovo od kterého hledáme antonyma
     */
    public static List GetAntonyms(String word) throws Exception{     
         
             
            List antonyms = new ArrayList(0);

            // bez určení slovní druhu
          String query =  " select se1.rank, w2.lemma, sy1.definition, sy2.definition from word w1 left join sense se1 on w1.wordid = se1.wordid left join synset sy1 on se1.synsetid = sy1.synsetid left join lexlinkref on sy1.synsetid = lexlinkref.synset1id and w1.wordid = lexlinkref.word1id left join synset sy2 on lexlinkref.synset2id = sy2.synsetid left join sense se2 on sy2.synsetid = se2.synsetid left join word w2 on se2.wordid = w2.wordid where w1.lemma =  "+quotate(word)+" and lexlinkref.linkid =30 order by se1.rank asc;";
                 
          antonyms = GetQuery(query);
    
    return antonyms;
    }
    
       /**
     * Metoda, která najde hyponyma od zadeného slova
     * @param word - slovo od kterého hledáme hyponyma
     */
    public static List GetTypes(String word) throws Exception{     
         
             
            List types = new ArrayList(0);

          String query =  " select se1.rank,w2.lemma from word w1 left join sense se1 on w1.wordid = se1.wordid left join synset sy1 on se1.synsetid = sy1.synsetid left join semlinkref on sy1.synsetid = semlinkref.synset1id left join synset sy2 on semlinkref.synset2id = sy2.synsetid left join sense se2 on sy2.synsetid = se2.synsetid left join word w2 on se2.wordid = w2.wordid where w1.lemma = "+quotate(word)+" and semlinkref.linkid = 2 order by se1.rank asc;";
  
          types = GetQuery(query);
   
    return types;
    }
    
    /**
     * Metoda, která najde hypernyma od zadeného slova
     * @param word - slovo od kterého hledáme hypernyma
     */
    public static List GetTypeOf(String word) throws Exception{     
         
             
            List typeOf = new ArrayList(0);
                   
       //   String query =  " select se1.rank,w2.lemma from word w1 left join sense se1 on w1.wordid = se1.wordid left join synset sy1 on se1.synsetid = sy1.synsetid left join semlinkref on sy1.synsetid = semlinkref.synset1id left join synset sy2 on semlinkref.synset2id = sy2.synsetid left join sense se2 on sy2.synsetid = se2.synsetid left join word w2 on se2.wordid = w2.wordid where w1.lemma = "+quotate(word)+" and semlinkref.linkid = 2 order by se1.rank asc;";
          String query =  "select se1.rank,w2.lemma from word w1 left join sense se1 on w1.wordid = se1.wordid left join synset sy1 on se1.synsetid = sy1.synsetid left join semlinkref on sy1.synsetid = semlinkref.synset1id left join synset sy2 on semlinkref.synset2id = sy2.synsetid left join sense se2 on sy2.synsetid = se2.synsetid left join word w2 on se2.wordid = w2.wordid where w1.lemma = "+quotate(word)+" and semlinkref.linkid = 1 order by se1.rank asc;";

          typeOf = GetQuery(query);
          
         
    return typeOf;
    }
    
    public static List GetQuery(String query) throws Exception{     
         
            List words = new ArrayList(0);
            String pom = "";
         
         try {
              ResultSet rs = MakeQuery(connect, query);

              while (rs.next()) {
                           if(!(words.contains(pom =rs.getString("lemma")))) words.add(pom);
                           //  sample = rs2.getString("sample");
                           //  sam = sam+"\""+ sample+"\"; ";

                          }
         }
       
         catch (Exception e) {
            System.out.println("Požadované slovo nebylo v antonymech nalezeno");
            throw e;
         }
    return words;
    }
    
    
    /**
     * Metoda, která najde synnset slova které zadáme v databázi
     * @param wordid - slovo jehož id hledáme
     */
    public static String FindSynsetId(String wordid) throws Exception{            
          
        try {
          String query =  "SELECT synsetid FROM sense WHERE wordid = "+quotate(wordid)+"";
                  
          
          ResultSet rs = MakeQuery(connect, query);
            
          if (rs.next()) return rs.getString("synsetid");
          else return null;
        
          } catch (Exception e) {
             System.out.println("Chyba při hledání id slova");
             throw e;
         }
         
     }
    
}
